// -------------------------------------------------------------------------------
// 
// 		cwCu		OvOwb_t@C
// 
// 				Ver 3.20f
// 
// -------------------------------------------------------------------------------

#ifndef DX_LOG_H
#define DX_LOG_H

// CN[h ------------------------------------------------------------------

#include "DxCompileConfig.h"
#include "DxFile.h"

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxLogWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
#include "Android/DxLogAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxLogiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

//cwCũeɗ͌炷ǂ̒`𔽉fׂ̃}N
#if !defined( DX_NON_LITERAL_STRING ) && !defined( DX_NON_LOG )
	#define DXSTRING( x )									x
	#define DXST_LOGFILE_ADDA( x )							LogFileAddA( x )
	#define DXST_LOGFILE_ADDW( x )							LogFileAddW( x )
	#define DXST_LOGFILE_ADDUTF16LE( x )					LogFileAddUTF16LE( x )
	#define DXST_LOGFILEFMT_ADDA( x )						LogFileFmtAddA x
	#define DXST_LOGFILEFMT_ADDW( x )						LogFileFmtAddW x
	#define DXST_LOGFILEFMT_ADDUTF16LE( x )					LogFileFmtAddUTF16LE x
	#define DXST_LOGFILE_ERRCODE_ADDA( ercode, x )			LogFileAddWithErrorCode_A( ercode, x )
	#define DXST_LOGFILE_ERRCODE_ADDW( ercode, x )			LogFileAddWithErrorCode_W( ercode, x )
	#define DXST_LOGFILE_ERRCODE_ADDUTF16LE( ercode, x )	LogFileAddWithErrorCode_UTF16LE( ercode, x )
	#define DXST_LOGFILEFMT_ERRCODE_ADDA( x )				LogFileFmtAddWithErrorCode_A x
	#define DXST_LOGFILEFMT_ERRCODE_ADDW( x )				LogFileFmtAddWithErrorCode_W x
	#define DXST_LOGFILEFMT_ERRCODE_ADDUTF16LE( x )			LogFileFmtAddWithErrorCode_UTF16LE x
	#define DXST_LOGFILE_TABADD								NS_LogFileTabAdd()
	#define DXST_LOGFILE_TABSUB								NS_LogFileTabSub()
	#define DXERRORNETLOG_ADD( x )							ErrorNetLogAdd( x )
	#define DXERRORNETWORK( x )								ErrorNetWork x
#else
	#define DXSTRING( x )									" "
	#define DXST_LOGFILE_ADDA( x )							(-1)
	#define DXST_LOGFILE_ADDW( x )							(-1)
	#define DXST_LOGFILE_ADDUTF16LE( x )					(-1)
	#define DXST_LOGFILEFMT_ADDA( x )						(-1)
	#define DXST_LOGFILEFMT_ADDW( x )						(-1)
	#define DXST_LOGFILEFMT_ADDUTF16LE( x )					(-1)
	#define DXST_LOGFILE_ERRCODE_ADDA( ercode, x )			(-1)
	#define DXST_LOGFILE_ERRCODE_ADDW( ercode, x )			(-1)
	#define DXST_LOGFILE_ERRCODE_ADDUTF16LE( ercode, x )	(-1)
	#define DXST_LOGFILEFMT_ERRCODE_ADDA( x )				(-1)
	#define DXST_LOGFILEFMT_ERRCODE_ADDW( x )				(-1)
	#define DXST_LOGFILEFMT_ERRCODE_ADDUTF16LE( x )			(-1)
	#define DXST_LOGFILE_TABADD								(0)
	#define DXST_LOGFILE_TABSUB								(0)
	#define DXERRORNETLOG_ADD( x )							(-1)
	#define DXERRORNETWORK( x )								(-1)
#endif


#ifndef DX_NON_LOG

#define LOG_MAXHEIGHT				(80)				// Pʂɓ郍O̍ős
#define LOG_MAXLENGTH				(255)				// Ps̃OɎg镶̒

// Op`
#define LOG_FONTSIZE				(16)				// OɎgtHg̃TCY
#define LOG_FONTTICK				(4)					// O\ɎgtHg̑
#define LOG_TABWIDTH				(4)					// ^u̕

// \̒` --------------------------------------------------------------------

// Of[^\
struct LOGDATA
{
	int						InitializeFlag ;					// tO

	int						NonUseTimeStampFlag ;				// ^CX^vo͂Ȃǂ̃tO
	int						NotLogOutFlag ;						// Oo͂stO(TRUEōsȂ)
	int						LogStartTime ;						// Ñ^CX^v
	wchar_t					UserLogFileName[ 256 ] ;			// SetApplicationLogFileName Őݒ肳ꂽOt@C
	wchar_t					LogOutDirectory[ FILEPATH_MAX ] ;	// Oo͂st@CۑfBNg
	int						UseLogDateName ;					// Oo͂st@Cɓt邩ǂ̃tO
	wchar_t					LogFileName[256] ;					// Oo͂st@C̖O
	int						LogFileTabNum ;						// Oõ͎^u̐
	int						LogFileTabStop ;					// Oõ͎^uo̓XgbvtO

#ifndef DX_NON_PRINTF_DX
	int						LogInitializeFlag ;					// Of[^Ă邩tO
	int						LogUserFontHandle ;					// [U[w̃O`ptHgnh
	int						LogFontHandle ;						// O`ptHgnh
	int						LogFontHandleLostFlag ;				// tHgnh폜ꂽۂɗtO
	int						LogX ,LogY ;						// ݂̃ÕJ[\ʒu
	wchar_t					LogString[LOG_MAXHEIGHT][LOG_MAXLENGTH] ; // O
	int						LogDrawFlag ;						// Oʏɕ\邩AtO
	int						LogFontSize ;						// OtHg̃TCY
	int						LogTabWidth ;						// Õ^u̕
	int						LogDrawWidth ;						// ݃J[\s̕`敝
	int						LogFileOutFlag ;					// Ot@Co͂邩AtO
	RECT					LogDrawArea ;						// O`悷̈
#endif // DX_NON_PRINTF_DX


	LOGDATA_PF				PF ;								// ˑ
} ;

// ϐ錾 --------------------------------------------------------------

extern LOGDATA LogData ;

// ֐vg^Cv錾-----------------------------------------------------------

// Oo͋@\֐
extern	int			LogFileInitialize(		void ) ;										// Ot@C
extern	int			LogFileTerminate(		void ) ;										// Ot@Čn

extern	int			LogFileAddA(			const char    *String ) ;						// Ot@Cɕo( char )
extern	int			LogFileAddW(			const wchar_t *String ) ;						// Ot@Cɕo( wchar_t )
extern	int			LogFileAddUTF16LE(		const char    *String ) ;						// Ot@Cɕo( UTF16LE )
extern 	int			LogFileFmtAddA(			const char    *FormatString , ... ) ;			// Ot@Cɏto( char )
extern 	int			LogFileFmtAddW(			const wchar_t *FormatString , ... ) ;			// Ot@Cɏto( wchar_t )
extern 	int			LogFileFmtAddUTF16LE(	const char    *FormatString , ... ) ;			// Ot@Cɏto( UTF16LE )

extern	int			LogFileAddWithErrorCode_A(			int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char    *ErrorStr ) ;					// Ot@CɕoAG[R[hݒ( char )
extern	int			LogFileAddWithErrorCode_W(			int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *ErrorStr ) ;					// Ot@CɕoAG[R[hݒ( wchar_t )
extern	int			LogFileAddWithErrorCode_UTF16LE(	int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char    *ErrorStr ) ;					// Ot@CɕoAG[R[hݒ( UTF16LE )
extern 	int			LogFileFmtAddWithErrorCode_A(		int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char	   *FormatString , ... ) ;			// Ot@CɏtoAG[R[hݒ( char )
extern 	int			LogFileFmtAddWithErrorCode_W(		int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *FormatString , ... ) ;			// Ot@CɏtoAG[R[hݒ( wchar_t )
extern 	int			LogFileFmtAddWithErrorCode_UTF16LE(	int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const char    *FormatString , ... ) ;			// Ot@CɏtoAG[R[hݒ( UTF16LE )

// wchar_tŊ֐
extern	int			LogFileAdd_WCHAR_T(		int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *ErrorStr ) ;					// Ot@C( Log.txt ) ɕo͂
extern 	int			LogFileFmtAdd_WCHAR_T(	int ErrorCode/* DX_ERRORCODE_WIN_24BIT_COLOR Ȃ*/, const wchar_t *FormatString , ... ) ;			// t Ot@C( Log.txt ) ɕo͂(  printf Ɠ )

extern	int			SetApplicationLogSaveDirectory_WCHAR_T(	const wchar_t *DirectoryPath );	// Ot@C( Log.txt ) ۑfBNgpXݒ肷
extern	int			SetApplicationLogFileName_WCHAR_T(      const wchar_t *FileName ) ;		// Ot@C̖Oݒ肷( Log.txt ȊOɂꍇɎgp )


// ˑ֐
extern	int			LogFileInitialize_PF( const wchar_t *LogFilePath ) ;					// Ot@C鏈̊ˑ
extern	int			LogFileTerminate_PF( void ) ;											// Ot@Čn̊ˑ
extern	int			LogFileAdd_WCHAR_T_PF( const wchar_t *LogFilePath, const wchar_t *ErrorStr ) ;	// Ot@C֕o̊ˑ



#ifndef DX_NON_PRINTF_DX

extern	int			IsInitializeLog( void ) ;												// O@\̏sǂ擾
extern	int			InitializeLog( void ) ;													// O@\̏
extern	int			TerminateLog( void ) ;													// Ǒns
extern	int			DrawLog( void ) ;														// O`悷
extern 	int			printfDxBase( const TCHAR *String ) ;									// printfDx ̏ł͂ȂƂo[W

// wchar_tŊ֐
extern 	int			printfDx_WCHAR_T(		 const wchar_t *FormatString , ... ) ;				// printf Ɠŉʂɕ\邽߂̊֐
extern 	int			printfDxBase_WCHAR_T(	 const wchar_t *String ) ;							// printfDx_WCHAR_T ̏ł͂ȂƂo[W
extern 	int			putsDx_WCHAR_T(			 const wchar_t *String , int NewLine ) ;			// puts Ɠŉʂɕ\邽߂̊֐

#endif // DX_NON_PRINTF_DX

#endif // DX_NON_LOG

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_LOG_H

